using System.Collections.Generic;
using HEAL.Attic;
#region License Information
/* HeuristicLab
 * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion


namespace HeuristicLab.Core {
  [StorableType("10644c62-bd66-440d-8204-d0c724c9f109")]
  public interface IConstrainedValueParameter<T> : IValueParameter<T> where T : class, IItem {
    IItemSet<T> ValidValues { get; }

    void Populate(IEnumerable<IItem> items);
    void Repopulate(IEnumerable<IItem> items);
  }
}
